
import java.io.*;
import java.util.*;

import static java.lang.Math.*;
import static java.lang.Integer.*;


/*
0) 45531448147500
1) 25820849184669
2) 357989040630494
3) 311794097434304
4) 2714220229484
5) 1008958005248
6) 1638796854851040
7) 12187508399128
8) 25573191751422
9) 239580125519231

N : 407
Holes count (Cnt) = 175
Holes area (Area) = 1486741164
Score  = 45531448147500
 */


public class RectanglesAndHoles {

	static PrintStream err = System.err;
	static long progtime = 0;
	
	static int N = 0;
	Random rnd = new Random();
	static boolean debug = true;
	
	static void debug(String s){
		if(debug){
			err.print(s);
		}
	}
	static void debug(int i){
		if(debug){
			err.print(i);
		}
	}
	
	List<R> rs = null;


	
	public int[] place(int[] A, int[] B){
		long start =  System.currentTimeMillis();


		int[] ret = null;
		N = A.length;
		List<R> orgs = new ArrayList<R>();
		rs = new ArrayList<R>();

		try{
			for(int i = 0; i < N; i++){
				R r = new R(A[i], B[i]);
				r.idx = i;
				rs.add(r);
				orgs.add(r);
			}
			
			// 
			Collections.sort(rs, new Comparator<R>() {
				@Override
				public int compare(R o1, R o2) {
					return o1.l - o2.l;
				}
			});
			
			mycalc3();

			ret = new int[N*3];
			for(int i = 0; i < N; i++){
				R r = orgs.get(i);
				ret[3*i] = r.lx;
				ret[3*i+1] = r.ly;
				ret[3*i+2] = r.d;
			}
			
		}
		catch(Exception ex){
			err.println(ex.getMessage());
		}
		
		progtime += System.currentTimeMillis() - start;
		return ret;
	}
	
	private void mycalc3() throws Exception{
		List<R> lines = new ArrayList<R>();
		R first = getFirst();
		first.yokonaga();
		first.set(0, 0);
		lines.add(first);
		
		// ꉞŏɑSɂ
		for(R r : rs){
			r.yokonaga();
		}
		G g = null;
		
		while(rs.size() >= 5){
			R last = lines.get(lines.size()-1);
			R r1, r2, r3, ru, rd;
			r1 = r2 = r3 = ru = rd = null;
			if(g != null){

				ru = rs.remove(0);
			}
			
			r1 = rs.remove(0);
			r2 = rs.remove(0);
			r3 = rs.remove(0);
			
			
			
			
			{// r1
				int ly = last.ry;
				int lx = last.rx;
				r1.set(ly, lx);
			}
			{// r3
				int ly = last.ry - r3.ta;
				int lx = r1.rx;
				r3.set(ly, lx);
			}
			{// r2
				int ly = 0;
				int lx = 0;
				if(last.ly <= r3.ly){
					ly = r3.ly - r2.ta;
					lx = last.rx;
				}
				else{
					ly = last.ly - r2.ta;
					lx = r3.lx - r2.yo;
				}
				
				r2.set(ly, lx);
			}
			if(g != null){// ru
				int ly,lx;
				if(g.r1.ry >= r1.ry){
					ly = r1.ry;
					lx = g.r1.rx;
				}
				else{
					ly = g.r1.ry;
					lx = r1.lx - ru.yo;
				}
				ru.set(ly, lx);
				lines.add(ru);
			}
			if(g != null){// rd
				rd = rs.remove(0);
				if(r2.ly >= last.ly || g != null && g.r2.ly >= last.ly){
					rs.add(0, rd);
					rd = null;
				}
				else{
					int ly,lx;
					if(g.r2.ly > r2.ly){
						ly = g.r2.ly - rd.ta;
						lx = r2.lx - rd.yo;
					}
					else{//S
						ly = r2.ly - rd.ta;
						lx = g.r2.rx;
					}
					rd.set(ly, lx);
					lines.add(rd);
				}
			}
			
			if(g == null){
				g = new G();
			}
			g.r1 = r1;
			g.r2 = r2;
			g.r3 = r3;
			lines.add(r1);
			lines.add(r2);
			lines.add(r3);

			
		}
		
		while(rs.size() > 0){
			R r = rs.remove(0);
			R last = lines.get(lines.size()-1);
			r.yokonaga();
			int ly = last.ly;
			int lx = last.rx;
			r.set(ly, lx);
			lines.add(r);
		}
	}
	
	class G{
		R r1 = null;
		R r2 = null;
		R r3 = null;
	}
	
	R getFirst(){
		List<R> f10 = new ArrayList<R>();
		for(int i = 0; i < 10; i++ ){
			f10.add(rs.get(rs.size()-1 - i));
		}
		Collections.sort(f10, new Comparator<R>() {

			@Override
			public int compare(R o1, R o2) {
				return o2.s - o1.s;
			}
			
		});
		R r = f10.get(0);
		rs.remove(r);
		return r;
	}
	

	
	
			
	
	class R{
		public R(int a, int b){
			this.a = a;
			this.b = b;
			l = Math.max(a, b);
			s = Math.min(a, b);
			yo = a;
			ta = b;
		}
		
		public void yokonaga(){
			if(b > a && d == 0){
				r();
			}
			if(a > b && d == 1){
				r();
			}
		}
		
		public void tatenaga(){
			if(a > b && d == 0){
				r();
			}
			if(b > a && d == 1){
				r();
			}
		}
		
		void r(){
			if(d == 0){
				d = 1;
				yo = b;
				ta = a;
			}
			else{
				d = 0;
				yo = a;
				ta = b;
			}
		}
		
		public void set(int ly, int lx){
			this.ly = ly;
			this.lx = lx;
			ry = ly + ta;
			rx = lx + yo;
			
		}
		
		int a = 0;
		int b = 0;
		int l = 0;
		int s = 0;
		int ta = 0;
		int yo = 0;
		int idx = 0;
		int ly = 0;
		int lx = 0;
		int ry = 0;
		int rx = 0;
		int d = 0;
	}
}
